/* Pentru un arbore se cunoaste sirul de tati.
    Sa se parcurga arborele in adancime
    Sa se determine inaltimea arborelui
*/
#include <fstream>
using namespace std;

ifstream fin("arbore.in");
ofstream fout("arbore.out");

const int MaxN = 101;
int n, root;
int t[MaxN];
int niv[MaxN]; // niv[x] = nivelul nodului x in arbore
int h[MaxN]; // h[x] = inaltimea arborelui in nodul x

void ReadArb();
void Df(int x, int nv);

int main()
{
    ReadArb();
    Df(root, 0);
    int hMax = 0;
    for (int i = 1; i <= n; ++i)
    {
        if (hMax < h[i])
            hMax = h[i];
    }
    fout << hMax;
    fout << '\n';
}

void Df(int x, int hCurent)
{
    //fout << x << ' ';
    h[x] = hCurent;
    for (int y = 1; y <= n;++y)
        if (t[y] == x)  // daca y este fiu al lui x
            Df(y, hCurent + 1);
}


void ReadArb()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> t[i];
    for (int i = 1; i <= n; ++i)
        if (t[i] == 0)
        {
            root = i;
            break;
        }
    h[root] = 0; // inaltimea radacinii este 0
}
