/* Pentru un arbore se cunoaste sirul de tati.
    Sa se parcurga arborele in adancime
*/
#include <fstream>
using namespace std;

ifstream fin("arbore.in");
ofstream fout("arbore.out");

const int MaxN = 101;
int n, root;
int t[MaxN];
int niv[MaxN]; // niv[x] = nivelul nodului x in arbore
void ReadArb();
void Df(int x, int nv);

int main()
{
    ReadArb();
    Df(root, 1);
    for (int i = 1; i <= n; ++i)
        fout << niv[i] << ' ';
    fout << '\n';
}

void Df(int x, int nv)
{
    //fout << x << ' ';
    niv[x] = nv;
    for (int y = 1; y <= n;++y)
        if (t[y] == x)  // daca y este fiu al lui x
            Df(y, nv + 1);
}


void ReadArb()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> t[i];
    for (int i = 1; i <= n; ++i)
        if (t[i] == 0)
        {
            root = i;
            break;
        }
}
