/* Parcurgeri in Arbori Binari
    Daca se cunosc sirurile st, dr
*/
#include <fstream>
using namespace std;

ifstream fin("arbBin.in");
ofstream fout("arbBin.out");

const int MaxN = 101;
int n, root;
int st[MaxN], dr[MaxN];
int t[MaxN];

void ReadArb();
void InOrd(int x);
void InPreord(int x);
void InPostord(int x);

int main()
{
   ReadArb();
   fout << n << '\n';
   InOrd(root);

}


void ReadArb()
{
    fin >> n;
    for (int i = 1; i <= n; ++i)
    {
        fin >> st[i] >> dr[i];
        t[st[i]] = i;
        t[dr[i]] = i;
    }

    for (int i = 1; i <= n; ++i)
        if (t[i] == 0)
        {
            root = i;
            break;
        }
}

void InOrd(int x)
{
    if (st[x])  // daca exista fiu stang
        InOrd(st[x]);
    fout << x << ' ';
    if (dr[x]) // daca exista fiu drept
        InOrd(dr[x]);
}

void InPreord(int x)
{
    fout<< x << " ";
    if( st[x])
        InPreord( st[x] );
    if(dr[x])
        InPreord(dr[x]);
}

void InPostord(int x)
{
    if( st[x])
        InPostord( st[x]);
    if( dr[x])
        InPostord( dr[x]);
    fout << x << " ";
}

